/**********************************************************************
 
	Copyright (C) 2003 Hirohisa MORI <joshua@nichibun.ac.jp>
 
	This program is free software; you can redistribute it 
	and/or modify it under the terms of the GLOBALBASE 
	Library General Public License (G-LGPL) as published by 

	http://www.globalbase.org/
 
	This program is distributed in the hope that it will be 
	useful, but WITHOUT ANY WARRANTY; without even the 
	implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE.

**********************************************************************/


#include	"xl.h"
#include	"xlerror.h"
#include	"utils.h"
#include	"memory_debug.h"

XL_SEXP * xl_SetThisAgentName();
extern L_CHAR * agent_name;

void
init_SetThisAgentName(XLISP_ENV * env)
{
	set_env(env,l_string(std_cm,"SetThisAgentName"),
		get_func_prim(xl_SetThisAgentName,FO_APPLICATIVE,0,2,2));
}

XL_SEXP *
xl_SetThisAgentName(XLISP_ENV * env,XL_SEXP * s)
{
XL_SEXP * an;
	an = get_el(s,1);
	if ( get_type(an) != XLT_STRING )
		goto type_missmatch;
	if ( agent_name )
		d_f_ree(agent_name);
	agent_name = ll_copy_str(an->string.data);
	return an;
type_missmatch:
	return get_error(
		s->h.file,
		s->h.line,
		XLE_SEMANTICS_TYPE_MISSMATCH,
		l_string(std_cm,"SetThisAgentName"),
		n_get_string("type missmatch"));
}
